%-- This code has been realized to illustrate neural network concepts during 
%-- the workshop organized by the "club EEA" which happened in March 2018 
%-- https://rnn2018lyon.sciencesconf.org/
%--
%-- This code has been strongly inspired by the Mooc of Andrew Ng on coursera
%-- https://www.coursera.org/learn/machine-learning/
%-- 
%-- The application treated here concerns the automatic recognition of 
%-- digits drawn by hand. This code is not protected by any license, you 
%-- can re-use it freely without any restriction. Please do not forget to
%-- cite this event for any use of the code.

function W = randInitializeWeights(L_in, L_out)

    %-- W = randInitializeWeights(L_in, L_out)
    %-- Randomly initialize the weights of a layer with L_in incoming 
    %-- connections and L_out outgoing connections
    %-- 
    %-- Note1: Initialize W randomly so that we break the symmetry while
    %-- training the neural network.
    %--
    %-- Note2: W should be set to a matrix of size(L_out, 1 + L_in) as
    %-- the column row of W handles the "bias" terms
    %--
    %-- Note3: The first row of W corresponds to the parameters for the 
    %-- bias units

    W = zeros(L_out,1+L_in);
    epsilon_init = 0.12;
    W = rand(L_out,1+L_in) * 2 * epsilon_init - epsilon_init;

end
