%-- This code has been realized to illustrate neural network concepts during 
%-- the workshop organized by the "club EEA" which happened in March 2018 
%-- https://rnn2018lyon.sciencesconf.org/
%--
%-- This code has been strongly inspired by the Mooc of Andrew Ng on coursera
%-- https://www.coursera.org/learn/machine-learning/
%-- 
%-- The application treated here concerns the automatic recognition of 
%-- digits drawn by hand. This code is not protected by any license, you 
%-- can re-use it freely without any restriction. Please do not forget to
%-- cite this event for any use of the code.

function download(filename, url, local_path )
    
    %-- DOWNLOAD Downloads a file from an URL to a local path (if needed)

    %-- check if the path is there 
    a = dir([local_path]);
    if ~verLessThan('matlab','9.1') % for 2016b matlab version or latter
        o = weboptions('CertificateFilename','');
    end
    if not(numel(a))
        %-- if not create it
        mkdir(local_path);
    end
    
    %-- check if file is in local path
    a = dir([local_path filename]);
    if not(numel(a))
        %-- if not download it
        disp(['Downloading ' url filename '. This may take a while.']);
        websave([local_path filename],[url filename]);
    end

end

