%-- This code has been realized to illustrate neural network concepts during 
%-- the workshop organized by the "club EEA" which happened in March 2018 
%-- https://rnn2018lyon.sciencesconf.org/
%--
%-- This code has been strongly inspired by the Mooc of Andrew Ng on coursera
%-- https://www.coursera.org/learn/machine-learning/
%-- 
%-- The application treated here concerns the automatic recognition of 
%-- digits drawn by hand. This code is not protected by any license, you 
%-- can re-use it freely without any restriction. Please do not forget to
%-- cite this event for any use of the code.

clear all;
close all;
clc;
addpath('../');


%-- Global parameter for the GUI application
global strTxt;
global imgCanevas;
imgCanevas = zeros(180,180);


%-- Display canevas
h = figure(1);
subplot(1,2,1); imagesc(imgCanevas); axis image; colormap(gray); 
title({'Draw a digit here','Press c to clear || v to display info'}); 
caxis([0 1]); axis off;
subplot(1,2,2); imagesc(zeros(40,40)); axis image; colormap(gray); 
caxis([0 1]); axis off;
set(gcf, 'Position', get(0, 'Screensize'));


%-- Compute and display text information on the overall performance
strTxt = visu.computeTxtInfo();
text(20,20,strTxt,'Color','green','HorizontalAlignment','center');


%-- Set a callback function with the 'WindowButtonDownFcn' and 'WindowButtonUpFcn' events for the rest of the application
set(gcf,'WindowButtonDownFcn', @visu.clickDownMakeDigit);
set(gcf,'WindowButtonUpFcn', @visu.clickUpMakeDigit);
set(gcf,'keypressfcn', @visu.keyPressDigit);

